(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/platform-browser'), require('@angular/core/testing'), require('jasmine-auto-spies')) :
    typeof define === 'function' && define.amd ? define('angular-unit-component-driver', ['exports', '@angular/platform-browser', '@angular/core/testing', 'jasmine-auto-spies'], factory) :
    (factory((global['angular-unit-component-driver'] = {}),global.ng.platformBrowser,global.ng.core.testing,global.jasmineAutoSpies));
}(this, (function (exports,platformBrowser,testing,jasmineAutoSpies) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var /**
     * @template T
     */ ComponentDriver = /** @class */ (function () {
        function ComponentDriver(fixture, TestBed) {
            this.fixture = fixture;
            this.TestBed = TestBed;
            // ComponentFixture implementation
            this.componentRef = this.fixture.componentRef;
            this.ngZone = this.fixture.ngZone;
            this.debugElement = this.fixture.debugElement;
            this.componentInstance = this.fixture.componentInstance;
            this.nativeElement = this.fixture.nativeElement;
            this.elementRef = this.fixture.elementRef;
            this.changeDetectorRef = this.fixture.changeDetectorRef;
            this.injector = { get: TestBed.get };
        }
        /**
         * @param {?=} checkNoChanges
         * @return {?}
         */
        ComponentDriver.prototype.detectChanges = /**
         * @param {?=} checkNoChanges
         * @return {?}
         */
            function (checkNoChanges) {
                this.fixture.detectChanges(checkNoChanges);
            };
        /**
         * @return {?}
         */
        ComponentDriver.prototype.checkNoChanges = /**
         * @return {?}
         */
            function () {
                this.fixture.checkNoChanges();
            };
        /**
         * @param {?=} autoDetect
         * @return {?}
         */
        ComponentDriver.prototype.autoDetectChanges = /**
         * @param {?=} autoDetect
         * @return {?}
         */
            function (autoDetect) {
                this.fixture.autoDetectChanges(autoDetect);
            };
        /**
         * @return {?}
         */
        ComponentDriver.prototype.isStable = /**
         * @return {?}
         */
            function () {
                return this.fixture.isStable();
            };
        /**
         * @return {?}
         */
        ComponentDriver.prototype.whenStable = /**
         * @return {?}
         */
            function () {
                return this.fixture.whenStable();
            };
        /**
         * @return {?}
         */
        ComponentDriver.prototype.whenRenderingDone = /**
         * @return {?}
         */
            function () {
                return this.fixture.whenRenderingDone();
            };
        /**
         * @return {?}
         */
        ComponentDriver.prototype.destroy = /**
         * @return {?}
         */
            function () {
                this.fixture.destroy();
            };
        /**
         * @protected
         * @template U
         * @param {?} selector
         * @return {?}
         */
        ComponentDriver.prototype.querySelector = /**
         * @protected
         * @template U
         * @param {?} selector
         * @return {?}
         */
            function (selector) {
                /** @type {?} */
                var debugElement = this.debugElement.query(platformBrowser.By.css(selector));
                return debugElement ? debugElement.nativeElement : null;
            };
        /**
         * @protected
         * @template U
         * @param {?} selector
         * @return {?}
         */
        ComponentDriver.prototype.querySelectorAll = /**
         * @protected
         * @template U
         * @param {?} selector
         * @return {?}
         */
            function (selector) {
                return this.debugElement.queryAll(platformBrowser.By.css(selector)).map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) { return element.nativeElement; }));
            };
        /**
         * @protected
         * @template U
         * @param {?} directive
         * @return {?}
         */
        ComponentDriver.prototype.queryDirective = /**
         * @protected
         * @template U
         * @param {?} directive
         * @return {?}
         */
            function (directive) {
                /** @type {?} */
                var debugElement = this.debugElement.query(platformBrowser.By.directive(directive));
                return debugElement ? debugElement.injector.get(directive) : null;
            };
        /**
         * @protected
         * @template U
         * @param {?} directive
         * @return {?}
         */
        ComponentDriver.prototype.queryDirectiveAll = /**
         * @protected
         * @template U
         * @param {?} directive
         * @return {?}
         */
            function (directive) {
                return this.debugElement
                    .queryAll(platformBrowser.By.directive(directive))
                    .map(( /**
             * @param {?} debugElement
             * @return {?}
             */function (debugElement) { return debugElement.injector.get(directive); }));
            };
        return ComponentDriver;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} __0
     * @return {?}
     */
    function componentTestingSetup(_a) {
        var componentClass = _a.componentClass, ComponentDriver = _a.driver, _b = _a.servicesToStub, servicesToStub = _b === void 0 ? [] : _b, _c = _a.declarations, declarations = _c === void 0 ? [] : _c, _d = _a.providers, providers = _d === void 0 ? [] : _d, _e = _a.overrideProviders, overrideProviders = _e === void 0 ? [] : _e, _f = _a.imports, imports = _f === void 0 ? [] : _f, _g = _a.schemas, schemas = _g === void 0 ? [] : _g;
        servicesToStub = servicesToStub.map(( /**
         * @param {?} serviceClass
         * @return {?}
         */function (serviceClass) {
            return ({
                provide: serviceClass,
                useValue: jasmineAutoSpies.createSpyFromClass(serviceClass)
            });
        }));
        overrideProviders = overrideProviders.map(( /**
         * @param {?} componentService
         * @return {?}
         */function (componentService) {
            return ({
                provide: componentService.clazz,
                useValue: componentService.mockValue
            });
        }));
        testing.TestBed.configureTestingModule({
            declarations: [componentClass].concat(declarations),
            providers: providers.concat(servicesToStub),
            imports: imports,
            schemas: schemas
        }).overrideComponent(componentClass, {
            set: {
                providers: overrideProviders
            }
        });
        return ( /** @type {?} */(new ComponentDriver(testing.TestBed.createComponent(componentClass), testing.TestBed)));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ComponentDriver = ComponentDriver;
    exports.componentTestingSetup = componentTestingSetup;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-unit-component-driver.umd.js.map