import { By } from '@angular/platform-browser';
import { TestBed } from '@angular/core/testing';
import { createSpyFromClass } from 'jasmine-auto-spies';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
class ComponentDriver {
    /**
     * @param {?} fixture
     * @param {?} TestBed
     */
    constructor(fixture, TestBed$$1) {
        this.fixture = fixture;
        this.TestBed = TestBed$$1;
        // ComponentFixture implementation
        this.componentRef = this.fixture.componentRef;
        this.ngZone = this.fixture.ngZone;
        this.debugElement = this.fixture.debugElement;
        this.componentInstance = this.fixture.componentInstance;
        this.nativeElement = this.fixture.nativeElement;
        this.elementRef = this.fixture.elementRef;
        this.changeDetectorRef = this.fixture.changeDetectorRef;
        this.injector = { get: TestBed$$1.get };
    }
    /**
     * @param {?=} checkNoChanges
     * @return {?}
     */
    detectChanges(checkNoChanges) {
        this.fixture.detectChanges(checkNoChanges);
    }
    /**
     * @return {?}
     */
    checkNoChanges() {
        this.fixture.checkNoChanges();
    }
    /**
     * @param {?=} autoDetect
     * @return {?}
     */
    autoDetectChanges(autoDetect) {
        this.fixture.autoDetectChanges(autoDetect);
    }
    /**
     * @return {?}
     */
    isStable() {
        return this.fixture.isStable();
    }
    /**
     * @return {?}
     */
    whenStable() {
        return this.fixture.whenStable();
    }
    /**
     * @return {?}
     */
    whenRenderingDone() {
        return this.fixture.whenRenderingDone();
    }
    /**
     * @return {?}
     */
    destroy() {
        this.fixture.destroy();
    }
    /**
     * @protected
     * @template U
     * @param {?} selector
     * @return {?}
     */
    querySelector(selector) {
        /** @type {?} */
        const debugElement = this.debugElement.query(By.css(selector));
        return debugElement ? debugElement.nativeElement : null;
    }
    /**
     * @protected
     * @template U
     * @param {?} selector
     * @return {?}
     */
    querySelectorAll(selector) {
        return this.debugElement.queryAll(By.css(selector)).map((/**
         * @param {?} element
         * @return {?}
         */
        element => element.nativeElement));
    }
    /**
     * @protected
     * @template U
     * @param {?} directive
     * @return {?}
     */
    queryDirective(directive) {
        /** @type {?} */
        const debugElement = this.debugElement.query(By.directive(directive));
        return debugElement ? debugElement.injector.get(directive) : null;
    }
    /**
     * @protected
     * @template U
     * @param {?} directive
     * @return {?}
     */
    queryDirectiveAll(directive) {
        return this.debugElement
            .queryAll(By.directive(directive))
            .map((/**
         * @param {?} debugElement
         * @return {?}
         */
        debugElement => debugElement.injector.get(directive)));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} __0
 * @return {?}
 */
function componentTestingSetup({ componentClass, driver: ComponentDriver, servicesToStub = [], declarations = [], providers = [], overrideProviders = [], imports = [], schemas = [] }) {
    servicesToStub = servicesToStub.map((/**
     * @param {?} serviceClass
     * @return {?}
     */
    serviceClass => ({
        provide: serviceClass,
        useValue: createSpyFromClass(serviceClass)
    })));
    overrideProviders = overrideProviders.map((/**
     * @param {?} componentService
     * @return {?}
     */
    (componentService) => ({
        provide: componentService.clazz,
        useValue: componentService.mockValue
    })));
    TestBed.configureTestingModule({
        declarations: [componentClass].concat(declarations),
        providers: providers.concat(servicesToStub),
        imports,
        schemas
    }).overrideComponent(componentClass, {
        set: {
            providers: overrideProviders
        }
    });
    return (/** @type {?} */ (new ComponentDriver(TestBed.createComponent(componentClass), TestBed)));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ComponentDriver, componentTestingSetup };

//# sourceMappingURL=angular-unit-component-driver.js.map