import { By } from '@angular/platform-browser';
import { TestBed } from '@angular/core/testing';
import { createSpyFromClass } from 'jasmine-auto-spies';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
ComponentDriver = /** @class */ (function () {
    function ComponentDriver(fixture, TestBed$$1) {
        this.fixture = fixture;
        this.TestBed = TestBed$$1;
        // ComponentFixture implementation
        this.componentRef = this.fixture.componentRef;
        this.ngZone = this.fixture.ngZone;
        this.debugElement = this.fixture.debugElement;
        this.componentInstance = this.fixture.componentInstance;
        this.nativeElement = this.fixture.nativeElement;
        this.elementRef = this.fixture.elementRef;
        this.changeDetectorRef = this.fixture.changeDetectorRef;
        this.injector = { get: TestBed$$1.get };
    }
    /**
     * @param {?=} checkNoChanges
     * @return {?}
     */
    ComponentDriver.prototype.detectChanges = /**
     * @param {?=} checkNoChanges
     * @return {?}
     */
    function (checkNoChanges) {
        this.fixture.detectChanges(checkNoChanges);
    };
    /**
     * @return {?}
     */
    ComponentDriver.prototype.checkNoChanges = /**
     * @return {?}
     */
    function () {
        this.fixture.checkNoChanges();
    };
    /**
     * @param {?=} autoDetect
     * @return {?}
     */
    ComponentDriver.prototype.autoDetectChanges = /**
     * @param {?=} autoDetect
     * @return {?}
     */
    function (autoDetect) {
        this.fixture.autoDetectChanges(autoDetect);
    };
    /**
     * @return {?}
     */
    ComponentDriver.prototype.isStable = /**
     * @return {?}
     */
    function () {
        return this.fixture.isStable();
    };
    /**
     * @return {?}
     */
    ComponentDriver.prototype.whenStable = /**
     * @return {?}
     */
    function () {
        return this.fixture.whenStable();
    };
    /**
     * @return {?}
     */
    ComponentDriver.prototype.whenRenderingDone = /**
     * @return {?}
     */
    function () {
        return this.fixture.whenRenderingDone();
    };
    /**
     * @return {?}
     */
    ComponentDriver.prototype.destroy = /**
     * @return {?}
     */
    function () {
        this.fixture.destroy();
    };
    /**
     * @protected
     * @template U
     * @param {?} selector
     * @return {?}
     */
    ComponentDriver.prototype.querySelector = /**
     * @protected
     * @template U
     * @param {?} selector
     * @return {?}
     */
    function (selector) {
        /** @type {?} */
        var debugElement = this.debugElement.query(By.css(selector));
        return debugElement ? debugElement.nativeElement : null;
    };
    /**
     * @protected
     * @template U
     * @param {?} selector
     * @return {?}
     */
    ComponentDriver.prototype.querySelectorAll = /**
     * @protected
     * @template U
     * @param {?} selector
     * @return {?}
     */
    function (selector) {
        return this.debugElement.queryAll(By.css(selector)).map((/**
         * @param {?} element
         * @return {?}
         */
        function (element) { return element.nativeElement; }));
    };
    /**
     * @protected
     * @template U
     * @param {?} directive
     * @return {?}
     */
    ComponentDriver.prototype.queryDirective = /**
     * @protected
     * @template U
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        /** @type {?} */
        var debugElement = this.debugElement.query(By.directive(directive));
        return debugElement ? debugElement.injector.get(directive) : null;
    };
    /**
     * @protected
     * @template U
     * @param {?} directive
     * @return {?}
     */
    ComponentDriver.prototype.queryDirectiveAll = /**
     * @protected
     * @template U
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        return this.debugElement
            .queryAll(By.directive(directive))
            .map((/**
         * @param {?} debugElement
         * @return {?}
         */
        function (debugElement) { return debugElement.injector.get(directive); }));
    };
    return ComponentDriver;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} __0
 * @return {?}
 */
function componentTestingSetup(_a) {
    var componentClass = _a.componentClass, ComponentDriver = _a.driver, _b = _a.servicesToStub, servicesToStub = _b === void 0 ? [] : _b, _c = _a.declarations, declarations = _c === void 0 ? [] : _c, _d = _a.providers, providers = _d === void 0 ? [] : _d, _e = _a.overrideProviders, overrideProviders = _e === void 0 ? [] : _e, _f = _a.imports, imports = _f === void 0 ? [] : _f, _g = _a.schemas, schemas = _g === void 0 ? [] : _g;
    servicesToStub = servicesToStub.map((/**
     * @param {?} serviceClass
     * @return {?}
     */
    function (serviceClass) { return ({
        provide: serviceClass,
        useValue: createSpyFromClass(serviceClass)
    }); }));
    overrideProviders = overrideProviders.map((/**
     * @param {?} componentService
     * @return {?}
     */
    function (componentService) { return ({
        provide: componentService.clazz,
        useValue: componentService.mockValue
    }); }));
    TestBed.configureTestingModule({
        declarations: [componentClass].concat(declarations),
        providers: providers.concat(servicesToStub),
        imports: imports,
        schemas: schemas
    }).overrideComponent(componentClass, {
        set: {
            providers: overrideProviders
        }
    });
    return (/** @type {?} */ (new ComponentDriver(TestBed.createComponent(componentClass), TestBed)));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ComponentDriver, componentTestingSetup };

//# sourceMappingURL=angular-unit-component-driver.js.map