import { ComponentFixture, TestBedStatic } from '@angular/core/testing';
import { Type } from '@angular/core';
declare type PublicPart<T> = {
    [P in keyof T]: T[P];
};
export declare class ComponentDriver<T = any> implements PublicPart<ComponentFixture<T>> {
    private fixture;
    TestBed: TestBedStatic;
    injector: {
        get(token: any, notFoundValue?: any): any;
    };
    componentRef: import("@angular/core").ComponentRef<T>;
    ngZone: import("@angular/core").NgZone;
    debugElement: import("@angular/core").DebugElement;
    componentInstance: T;
    nativeElement: any;
    elementRef: import("@angular/core").ElementRef<any>;
    changeDetectorRef: import("@angular/core").ChangeDetectorRef;
    detectChanges(checkNoChanges?: boolean): void;
    checkNoChanges(): void;
    autoDetectChanges(autoDetect?: boolean): void;
    isStable(): boolean;
    whenStable(): Promise<any>;
    whenRenderingDone(): Promise<any>;
    destroy(): void;
    constructor(fixture: ComponentFixture<T>, TestBed: TestBedStatic);
    protected querySelector<U = HTMLElement>(selector: string): U;
    protected querySelectorAll<U = HTMLElement>(selector: string): U[];
    protected queryDirective<U>(directive: Type<U>): U;
    protected queryDirectiveAll<U>(directive: Type<U>): U[];
}
export {};
